//------------------------------------
//2006  
//------------------------------------
#include "stdafx.h"
#include "resource.h"
#include <commctrl.h>
#include <stdlib.h>
#include <stdio.h>
#include "vis.h"
#include "About.h"

#define		INIFILE		"wa.ini"
#define		DEF_FREQ	"0"
#define		DEF_TRESH	"0"
#define		DEF_DELAY	"1"
#define		DEF_LATENCY	"1"

int				ConfigDlgCreated= false;
HWND			g_hDlg  = NULL;

extern	char			description[];
extern	DWORD			freq[4];
extern	BYTE			tresh[4];
extern	HINSTANCE		hInst;
extern	winampVisModule mod1;

//-------------------------------------------------------------------------
//GetParamFromIni()
//-------------------------------------------------------------------------
void GetParamFromIni(void)
{
	char	inipath[256];
	FILE*	IniFile;
	TCHAR	buf[32];

	GetCurrentDirectory(sizeof(inipath), inipath);
	sprintf(inipath, "%s\\Plugins\\%s", inipath, INIFILE);
	IniFile = fopen(inipath, "a+");

	//
	GetPrivateProfileString("Settings", "Freq0", DEF_FREQ, buf, sizeof(buf), inipath);
	freq[0] = atoi(buf);
	GetPrivateProfileString("Settings", "Freq1", DEF_FREQ, buf, sizeof(buf), inipath);
	freq[1] = atoi(buf);
	GetPrivateProfileString("Settings", "Freq2", DEF_FREQ, buf, sizeof(buf), inipath);
	freq[2] = atoi(buf);
	GetPrivateProfileString("Settings", "Freq3", DEF_FREQ, buf, sizeof(buf), inipath);
	freq[3] = atoi(buf);

	//
	GetPrivateProfileString("Settings", "Tresh0", DEF_TRESH, buf, sizeof(buf), inipath);
	tresh[0] = atoi(buf);
	GetPrivateProfileString("Settings", "Tresh1", DEF_TRESH, buf, sizeof(buf), inipath);
	tresh[1] = atoi(buf);
	GetPrivateProfileString("Settings", "Tresh2", DEF_TRESH, buf, sizeof(buf), inipath);
	tresh[2] = atoi(buf);
	GetPrivateProfileString("Settings", "Tresh3", DEF_TRESH, buf, sizeof(buf), inipath);
	tresh[3] = atoi(buf);

	//
	GetPrivateProfileString("Settings", "Latency", DEF_LATENCY, buf, sizeof(buf), inipath);
	mod1.latencyMs=atoi(buf);

	//
	GetPrivateProfileString("Settings", "Delay", DEF_DELAY, buf, sizeof(buf), inipath);
	mod1.delayMs=atoi(buf);

	fclose(IniFile);
}

//-------------------------------------------------------------------------
//PutParamToIni()
//-------------------------------------------------------------------------
void PutParamToIni(void)
{
	char	inipath[256];
	FILE*	IniFile;
	char	buf[32];

	GetCurrentDirectory(sizeof(inipath), inipath);
	sprintf(inipath, "%s\\Plugins\\%s", inipath, INIFILE);
	IniFile = fopen(inipath, "a+");

	//
	_itoa(freq[0], buf, 10);
	WritePrivateProfileString("Settings", "Freq0", buf, inipath);
	_itoa(freq[1], buf, 10);
	WritePrivateProfileString("Settings", "Freq1", buf, inipath);
	_itoa(freq[2], buf, 10);
	WritePrivateProfileString("Settings", "Freq2", buf, inipath);
	_itoa(freq[3], buf, 10);
	WritePrivateProfileString("Settings", "Freq3", buf, inipath);

	//
	_itoa(tresh[0], buf, 10);
	WritePrivateProfileString("Settings", "Tresh0", buf, inipath);
	_itoa(tresh[1], buf, 10);
	WritePrivateProfileString("Settings", "Tresh1", buf, inipath);
	_itoa(tresh[2], buf, 10);
	WritePrivateProfileString("Settings", "Tresh2", buf, inipath);
	_itoa(tresh[3], buf, 10);
	WritePrivateProfileString("Settings", "Tresh3", buf, inipath);

	//
	_itoa(mod1.latencyMs, buf, 10);
	WritePrivateProfileString("Settings", "Latency", buf, inipath);

	//
	_itoa(mod1.delayMs, buf, 10);
	WritePrivateProfileString("Settings", "Delay", buf, inipath);

	fclose(IniFile);
}
//-------------------------------------------------------------------------
//ConfigDlgProc()
//-------------------------------------------------------------------------
BOOL CALLBACK ConfigDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	int		i;
	DWORD	dwPos;
	char	str[8];

	switch (uMsg)
	{
		case WM_INITDIALOG:
			if(ConfigDlgCreated)
					EndDialog(hDlg, false);
			
			ConfigDlgCreated = true;

			g_hDlg = hDlg;

			SetWindowText(hDlg, description);

			GetParamFromIni();

			//
			for(i=0; i<IDC_SLIDER4-IDC_SLIDER1+1; i++)
			{
				SendMessage(GetDlgItem(hDlg, IDC_SLIDER1+i), TBM_SETRANGE, (WPARAM) TRUE,	// redraw flag 
									(LPARAM) MAKELONG(-575,0));	// min. & max. positions 
			    SendMessage(GetDlgItem(hDlg, IDC_SLIDER1+i), TBM_SETPOS, (WPARAM) TRUE,	// redraw flag 
									(LPARAM) -freq[i]); 
				
				dwPos = SendMessage(GetDlgItem(hDlg, IDC_SLIDER1+i), TBM_GETPOS, 0, 0);

				_itoa(0-dwPos, str, 10);
				SetWindowText(GetDlgItem(hDlg, IDC_STATIC1+i), str);
			}
			
			//
			for(i=0; i<IDC_SLIDER8-IDC_SLIDER4+1; i++)
			{
				SendMessage(GetDlgItem(hDlg, IDC_SLIDER5+i), TBM_SETRANGE, (WPARAM) TRUE,	// redraw flag 
									(LPARAM) MAKELONG(-255,0));	// min. & max. positions 
			    SendMessage(GetDlgItem(hDlg, IDC_SLIDER5+i), TBM_SETPOS, (WPARAM) TRUE,	// redraw flag 
									(LPARAM) -tresh[i]); 
				dwPos = SendMessage(GetDlgItem(hDlg, IDC_SLIDER5+i), TBM_GETPOS, 0, 0);

				_itoa(0-dwPos, str, 10);
				SetWindowText(GetDlgItem(hDlg, IDC_STATIC5+i), str);
			}

			//
			SendMessage(GetDlgItem(hDlg, IDC_SLIDER_LATENCY), TBM_SETRANGE, (WPARAM) TRUE,	// redraw flag 
								(LPARAM) MAKELONG(0,255));	// min. & max. positions 
		    SendMessage(GetDlgItem(hDlg, IDC_SLIDER_LATENCY), TBM_SETPOS, (WPARAM) TRUE,	// redraw flag 
								(LPARAM) mod1.latencyMs); 
			dwPos = SendMessage(GetDlgItem(hDlg, IDC_SLIDER_LATENCY), TBM_GETPOS, 0, 0);

			_itoa(dwPos, str, 10);
			SetWindowText(GetDlgItem(hDlg, IDC_STATIC_LATENCY), str);

			//
			SendMessage(GetDlgItem(hDlg, IDC_SLIDER_DELAY), TBM_SETRANGE, (WPARAM) TRUE,	// redraw flag 
								(LPARAM) MAKELONG(0,255));	// min. & max. positions 
		    SendMessage(GetDlgItem(hDlg, IDC_SLIDER_DELAY), TBM_SETPOS, (WPARAM) TRUE,	// redraw flag 
								(LPARAM) mod1.delayMs); 
			dwPos = SendMessage(GetDlgItem(hDlg, IDC_SLIDER_DELAY), TBM_GETPOS, 0, 0);

			_itoa(dwPos, str, 10);
			SetWindowText(GetDlgItem(hDlg, IDC_STATIC_DELAY), str);


			return TRUE;


		case WM_DESTROY:
			return TRUE;

		case WM_HSCROLL:
		case WM_VSCROLL:

			for(i=0; i<4; i++)
			{			
				dwPos = SendMessage(GetDlgItem(hDlg, IDC_SLIDER1+i), TBM_GETPOS, 0, 0); 
				_itoa(0-dwPos, str, 10);
				SetWindowText(GetDlgItem(hDlg, IDC_STATIC1+i), str);
				freq[i]=(0-dwPos);
			}

			for(i=0; i<4; i++)
			{			
				dwPos = SendMessage(GetDlgItem(hDlg, IDC_SLIDER5+i), TBM_GETPOS, 0, 0); 
				_itoa(0-dwPos, str, 10);
				SetWindowText(GetDlgItem(hDlg, IDC_STATIC5+i), str);
				tresh[i]=(0-dwPos);
			}

			dwPos = SendMessage(GetDlgItem(hDlg, IDC_SLIDER_LATENCY), TBM_GETPOS, 0, 0); 
			_itoa(dwPos, str, 10);
			SetWindowText(GetDlgItem(hDlg, IDC_STATIC_LATENCY), str);
			mod1.latencyMs=dwPos;

			dwPos = SendMessage(GetDlgItem(hDlg, IDC_SLIDER_DELAY), TBM_GETPOS, 0, 0); 
			_itoa(dwPos, str, 10);
			SetWindowText(GetDlgItem(hDlg, IDC_STATIC_DELAY), str);
			mod1.delayMs=dwPos;


			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				PutParamToIni();
				ConfigDlgCreated = false;
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}

			if(LOWORD(wParam) == IDC_BUTTON_ABOUT)
				DialogBox(hInst, (LPCTSTR)IDD_DIALOG_ABOUT, 0, (DLGPROC)AboutDlgProc);
			break;
	}

    return FALSE;
}