// wa.cpp : Defines the entry point for the DLL application.
//
//------------------------------------
//2006  
//------------------------------------
#include "stdafx.h"
#include <stdio.h>
#include "wa.h"
#include "vis.h"
#include "drvr.h"
#include "resource.h"
#include "dlgconfig.h"

winampVisModule *getModule(int);
void			config(struct winampVisModule *this_mod); // configuration dialog
int				init(struct winampVisModule *this_mod);
int				render(struct winampVisModule *this_mod);
void			quit(struct winampVisModule *this_mod);

HINSTANCE			hInst;
HWND			hDlgConfig;
winampVisHeader hdr;
char			description[] = "LPT visualisation module";
HANDLE			hSCManager;
HANDLE			hFile;
char			DriverName[64] = "io_231";
char			DriverPath[64];
char			SymbolLink[64] = "slIO";

DWORD			freq[4];
BYTE			tresh[4];

winampVisModule mod1 =
{
	"LPT visualisation module",
	NULL,	// hwndParent
	NULL,	// hDllInstance
	0,		// sRate
	0,		// nCh
	1,		// latencyMS
	1,		// delayMS
	2,		// spectrumNch
	0,		// waveformNch
	{ 0, },	// spectrumData
	{ 0, },	// waveformData
	config,
	init,
	render, 
	quit
};

struct 
{
	BYTE null;
	BYTE byte;
	WORD port;
}inout;

void WriteLPT(char data)
{
	DWORD a;

	inout.byte = data;
	inout.port = 0x037c;	// 
	WriteFile(hFile, (void*)&inout, sizeof(inout), &a, NULL);
}

void InitLPT(void)
{
	DWORD a;

	// LPT   EPP
	inout.byte = 0x00;
	inout.port = 0x037a;
	WriteFile(hFile, (void*)&inout, sizeof(inout), &a, NULL);
}

BOOL APIENTRY DllMain( HINSTANCE hinstDLL, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	hInst = hinstDLL;

    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

extern "C"
__declspec( dllexport ) winampVisHeader* winampVisGetHeader()
{
	hdr.description = description;
	hdr.version = VIS_HDRVER;
	hdr.getModule = &getModule;
	return &hdr;
}

//------------------------------------------------
//getModule()
//------------------------------------------------
winampVisModule *getModule(int which)
{
	switch (which)
	{
		case 0: return &mod1;
		default:return NULL;
	}
}

//------------------------------------------------
//config()
//------------------------------------------------
void config(struct winampVisModule *this_mod)
{
	DialogBox(hInst, (LPCTSTR)IDD_DIALOG_CONFIG, hDlgConfig, (DLGPROC)ConfigDlgProc);
}

//------------------------------------------------
//init()
//------------------------------------------------
int init(struct winampVisModule *this_mod)
{
	char	DriverExe[64];
	TCHAR   completeDeviceName[64];
	int		hRet;

	sprintf(DriverExe, "%s%s", DriverName, ".sys");
	GetSystemDirectory(DriverPath, sizeof(DriverPath) );
	sprintf(DriverPath, "%s%s%s", DriverPath, "\\drivers\\", DriverExe);
	
	hSCManager = OpenSCManager(	NULL, NULL, SC_MANAGER_ALL_ACCESS);
	RemoveDriver( hSCManager, DriverName );
	InstallDriver( hSCManager, DriverName, DriverPath );
	hRet = StartDriver( hSCManager, DriverName );
	if(!hRet)
	{
		MessageBox(NULL, "Warning: StartDriver() failed", "ERROR", MB_OK);
	}
	
	if( (GetVersion() & 0xFF) >= 5 )
		wsprintf( completeDeviceName, TEXT("\\\\.\\Global\\%s"), SymbolLink );

	else
		wsprintf( completeDeviceName, TEXT("\\\\.\\%s"), SymbolLink );

	hFile = CreateFile(completeDeviceName, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	InitLPT();

	GetParamFromIni();

	return 0;//success
}

//------------------------------------------------
//quit()
//------------------------------------------------
void quit(struct winampVisModule *this_mod)
{
	if(hFile != NULL)
	{
		CloseHandle(hFile);
		hFile = NULL;
	}
	
	StopService(hSCManager, DriverName);
	RemoveDriver( hSCManager, DriverName );
}

//------------------------------------------------
//render()
//------------------------------------------------
int render(struct winampVisModule *this_mod)
{
	unsigned char outb = 0;
	
	for(int i=0; i<4; i++)
	{
		if( this_mod->spectrumData[1][freq[i]] > tresh[i] )
		{
			outb = outb | (1<<i);
		}
	}

	WriteLPT(outb);
	return 0;
}
