//------------------------------------
//2006  
//------------------------------------
#include <WDM.H>
#include "strmini.h"
#include "ntstatus.h"

NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING RegistryPath);
VOID     DrvUnload(IN PDRIVER_OBJECT DriverObject );
NTSTATUS OnCreateClose( PDEVICE_OBJECT HookDevice, IN PIRP Irp );
NTSTATUS OnRead( PDEVICE_OBJECT HookDevice, IN PIRP Irp );
NTSTATUS OnWrite( PDEVICE_OBJECT HookDevice, IN PIRP Irp );

#pragma alloc_text(INIT, DriverEntry)


//globals
PDRIVER_OBJECT      MyDriver;

#define IOCTL_DRIVER_MAIN  CTL_CODE(FILE_DEVICE_STREAMS, 0x0800, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)

//---------------------------------------------------------------------------------
//DriverEntry()
//---------------------------------------------------------------------------------
NTSTATUS DriverEntry(
                        IN PDRIVER_OBJECT pDriverObject, 
                        IN PUNICODE_STRING RegistryPath
                    )
{
    WCHAR                   deviceNameBuffer[]  = L"\\Device\\devIO";
    UNICODE_STRING          deviceNameUnicodeString;
    WCHAR                   deviceLinkBuffer[]  = L"\\DosDevices\\slIO";
    UNICODE_STRING          deviceLinkUnicodeString;

	NTSTATUS                ntStatus;
	PDEVICE_OBJECT          guiDevice;


	MyDriver = pDriverObject;

    RtlInitUnicodeString (&deviceNameUnicodeString, deviceNameBuffer );

	ntStatus = IoCreateDevice ( pDriverObject,
                                0,
                                &deviceNameUnicodeString,
                                FILE_DEVICE_STREAMS,
                                0,
                                FALSE,
                                &guiDevice );
	if(NT_SUCCESS(ntStatus))
	{
		RtlInitUnicodeString (&deviceLinkUnicodeString,
                              deviceLinkBuffer );
        ntStatus = IoCreateSymbolicLink (&deviceLinkUnicodeString,
                                         &deviceNameUnicodeString );
       if(!NT_SUCCESS(ntStatus)) {

            IoDeleteDevice( guiDevice );
            return ntStatus;            
        }

	}

	pDriverObject->MajorFunction[IRP_MJ_CREATE ] = OnCreateClose;
	pDriverObject->MajorFunction[IRP_MJ_CLEANUP] = OnCreateClose;
	pDriverObject->MajorFunction[IRP_MJ_READ   ] = OnRead;
	pDriverObject->MajorFunction[IRP_MJ_WRITE  ] = OnWrite;
	pDriverObject->DriverUnload = DrvUnload;

    return STATUS_SUCCESS;
}

//---------------------------------------------------------------------------------
//DrvUnload()
//---------------------------------------------------------------------------------
VOID 
DrvUnload( 
    IN PDRIVER_OBJECT DriverObject 
    )
{
    WCHAR                  deviceLinkBuffer[]  = L"\\DosDevices\\slIO";
    UNICODE_STRING         deviceLinkUnicodeString;
	
	RtlInitUnicodeString( &deviceLinkUnicodeString, deviceLinkBuffer );
	IoDeleteSymbolicLink( &deviceLinkUnicodeString );


    IoDeleteDevice( DriverObject->DeviceObject );
}

//---------------------------------------------------------------------------------
//OnCreateClose()
//---------------------------------------------------------------------------------
NTSTATUS OnCreateClose( PDEVICE_OBJECT HookDevice, IN PIRP Irp )
{
	Irp->IoStatus.Status = STATUS_SUCCESS;
	Irp->IoStatus.Information = 0;

	return STATUS_SUCCESS;
}

NTSTATUS OnRead( PDEVICE_OBJECT HookDevice, IN PIRP Irp )
{
	DWORD *Buffer;

	Buffer = (DWORD*)Irp->UserBuffer;			//Buffer
	if(!Buffer)
		return STATUS_INVALID_PARAMETER;
	__asm
	{
		lea eax, Buffer
		mov ecx, dword ptr [eax]
		mov dx,  word ptr [ecx+2]
		in al, dx
		mov byte ptr [ecx+1], al
	}

	Irp->IoStatus.Information = 1;   //  NumberOfBytesRead
	return STATUS_SUCCESS;
}

NTSTATUS OnWrite( PDEVICE_OBJECT HookDevice, IN PIRP Irp )
{
	DWORD *Buffer;

	Buffer = (DWORD*)Irp->UserBuffer;			//Buffer
	if(!Buffer)
		return STATUS_INVALID_PARAMETER;
	__asm
	{
		lea eax, Buffer
		mov eax, dword ptr [eax]
		mov dx, word ptr [eax+2]
		mov al, byte ptr [eax+1]
		out dx, al 
	}

	Irp->IoStatus.Information = 1;   //  NumberOfBytesRead
	return STATUS_SUCCESS;
}